diff -r c2f2fb1df9ed -r 2d81a4c055f3 scripts/plot/appearance/legend.m
--- a/scripts/plot/appearance/legend.m	Thu Oct 24 22:33:37 2019 +0200
+++ b/scripts/plot/appearance/legend.m	Mon Oct 28 17:47:06 2019 +0100
@@ -1393,10 +1058,11 @@
 %!demo
 %! clf;
 %! x = 0:1;
-%! plot (x,x,";I am Blue;", x,2*x, x,3*x,";I am yellow;");
-%! h = legend ("location", "northeastoutside");
+%! hline = plot (x,x,";I am Blue;", x,2*x, x,3*x,";I am yellow;");
+%! h = legend ();
+%! set (h, "location", "northeastoutside");
 %! ## Placing legend inside returns axes to original size
-%! legend (h, "location", "northeast");
+%! set (h, "location", "northeast");
 %! title ("Blue and Yellow keys, with Orange missing");
 
 %!demo
@@ -1603,7 +1269,7 @@
 %! clf;
 %! plot (rand (2));
 %! title ("legend() will warn if extra labels are specified");
-%! legend ("Hello", "World", "interpreter", "foobar");
+%! legend ("Hello", "World", "foo", "bar");
 
 %!demo
 %! clf;
@@ -1761,87 +1427,121 @@
 %!  legend ({"12345678901234567890"}, "location", "southwestoutside");
 %!  legend (option);
 
-%!demo  # bug 39697
-%! clf;
-%! plot (1:10);
-%! legend ("Legend Text");
-%! title ({"Multi-line", "titles", "are a", "problem", "See bug #39697"});
-
-%!testif ; any (strcmp ("gnuplot", available_graphics_toolkits ()))
-%! toolkit = graphics_toolkit ("gnuplot");
-%! h = figure ("visible", "off");
+## Test input validation
+%!test
+%! hf = figure ("visible", "off");
 %! unwind_protect
-%!   position = get (h, "position");
-%!   plot (rand (3));
-%!   legend ();
-%!   filename = sprintf ("%s.eps", tempname ());
-%!   print (filename);
-%!   unlink (filename);
-%!   assert (get (h, "position"), position);
+%!   try
+%!     legend ();
+%!   catch
+%!     [~, id] = lasterr ();
+%!     assert (id, "Octave:legend:no-object");
+%!   end_try_catch
 %! unwind_protect_cleanup
-%!   close (h);
-%!   graphics_toolkit (toolkit);
-%! end_unwind_protect
-
-%!test <*42035>
-%! h = figure ("visible", "off");
-%! unwind_protect
-%!   hax1 = subplot (1,2,1);
-%!   plot (1:10);
-%!   hax2 = subplot (1,2,2);
-%!   plot (1:10);
-%!   hleg1 = legend (hax1, "foo");
-%!   assert (getappdata (hleg1, "__axes_handle__"), hax1);
-%!   assert (gca (), hax2);
-%!   hleg2 = legend ("bar");
-%!   assert (getappdata (hleg2, "__axes_handle__"), gca ());
-%! unwind_protect_cleanup
-%!   close (h);
+%!   close (hf);
 %! end_unwind_protect
 
 %!test
-%! ## Difficult example from plotyy demo #1
+%! hf = figure ("visible", "off");
+%! unwind_protect
+%!   axes ();
+%!   try
+%!     legend ();
+%!   catch
+%!     [~, id] = lasterr ();
+%!     assert (id, "Octave:legend:no-object");
+%!   end_try_catch
+%! unwind_protect_cleanup
+%!   close (hf);
+%! end_unwind_protect
+
+%!test
 %! hf = figure ("visible", "off");
 %! unwind_protect
-%!   x = 0:0.1:2*pi;
-%!   y1 = sin (x);
-%!   y2 = exp (x - 1);
-%!   hax = plotyy (x,y1, x-1,y2, @plot, @semilogy);
-%!   text (0.5, 0.5, "Left Axis", "parent", hax(1));
-%!   text (4.5, 80, "Right Axis", "parent", hax(2));
-%!   hleg = legend ("show");
-%!   assert (get (hleg, "string"), {"data1", "data2"});
-%!   fail ("legend ('foo', 'bar', 'baz')", "warning", "ignoring extra labels");
+%!   axes ();
+%!   light ();
+%!   try
+%!     legend ();
+%!   catch
+%!     [~, id] = lasterr ();
+%!     assert (id, "Octave:legend:no-object");
+%!   end_try_catch
+%! unwind_protect_cleanup
+%!   close (hf);
+%! end_unwind_protect
+
+%!test
+%! hf = figure ("visible", "off");
+%! unwind_protect
+%!   axes ();
+%!   hli = light ();
+%!   try
+%!     legend (hli);
+%!   catch
+%!     [~, id] = lasterr ();
+%!     assert (id, "Octave:legend:bad-object");
+%!   end_try_catch
 %! unwind_protect_cleanup
 %!   close (hf);
 %! end_unwind_protect
 
 %!test
-%! ## Test warnings about objects to label
 %! hf = figure ("visible", "off");
 %! unwind_protect
-%!   hax = gca ();
-%!   fail ("legend ('foobar')", "warning", "plot data is empty");
-%!   ht = text (0.5, 0.5, "Hello World");
-%!   fail ("legend ('foobar')", "warning", "plot data is empty");
-%!   lastwarn ("");   # clear warning
-%!   hleg = legend ();
-%!   assert (isempty (hleg) && isempty (lastwarn ()));
-%!   fail ("legend ('foobar')", "warning", "plot data is empty");
-%!   hln = line ([0 1], [0 1]);
-%!   fail ("legend ('foo', 'bar')", "warning", "ignoring extra labels");
-%!   plot (rand (2, 21));
-%!   fail ("legend ()", "warning", "labeling only first 20 data objects");
+%!   axes ();
+%!   hplot = plot (rand (3));
+%!   try
+%!     legend (hplot, struct);
+%!   catch
+%!     [~, id] = lasterr ();
+%!     assert (id, "Octave:invalid-fun-call");
+%!   end_try_catch
 %! unwind_protect_cleanup
 %!   close (hf);
 %! end_unwind_protect
 
 %!test
-%! ## Test warnings about unsupported features
 %! hf = figure ("visible", "off");
 %! unwind_protect
-%!   plot (1:10);
-%!   fail ("legend ('location','best')", "warning", "'best' not yet implemented");
+%!   axes ();
+%!   hplot = plot (rand (3));
+%!   try
+%!     legend ("a", "b", "c", hplot);
+%!   catch
+%!     [~, id] = lasterr ();
+%!     assert (id, "Octave:invalid-fun-call");
+%!   end_try_catch
 %! unwind_protect_cleanup
 %!   close (hf);
 %! end_unwind_protect
+
+## Test bugs in previous implementation
+%!test <39697>
+%! hf = figure ("visible", "off");
+%! unwind_protect
+%!   axes ("units", "normalized");
+%!   plot (1:10);
+%!   hl = legend ("Legend Text", "units", "normalized");
+%!   title ({'Multi-line', 'titles', 'are a', 'problem'});
+%!   pos = get (gca, 'position');
+%!   axtop = sum (pos(2:2:4));
+%!   pos = get (hl, 'position');
+%!   legtop = sum (pos(2:2:4));
+%!   assert (legtop < axtop);
+%! unwind_protect_cleanup
+%!   close (hf);
+%! end_unwind_protect
+
+%!test <40333>
+%! hf = figure ("visible", "off");
+%! unwind_protect
+%!   axes ("units", "normalized");
+%!   plot (1:10);
+%!   hl = legend ("Legend Text", "units", "normalized");
+%!   pos = get (gca, 'position');
+%!   set (hf, 'position', [0 0 200 200]);
+%!   set (hl, 'fontsize', 20);
+%!   assert (get (gca, 'position'), pos, 2*eps);
+%! unwind_protect_cleanup
+%!   close (hf);
+%! end_unwind_protect
